#include "apilib.h"
#include <stdio.h>

#define RGB(r,g,b)		16 + r + g * 6 + b * 36

int strtol(char *s, char **endp, int base);	/* W֐istdlib.hj */

char *skipspace(char *p);
void textview(int win, int w, int h, int xskip, char *p, int tab, int lang);
char *lineview(int win, int w, int y, int xskip, unsigned char *p, int tab, int lang);
int puttab(int x, int w, int xskip, char *s, int tab);

int nowline = 0;

int main(void)
{
	short winbuf[1024 * 800];
	char txtbuf[240 * 1024];
	int w = 30, h = 10, t = 4, spd_x = 1, spd_y = 1;
	int win, i, j, lang = api_getlang(), xskip = 0;
	char s[30], *p, *q = 0, *r = 0;

	q = "files.txt";

	/* EBhȄ */
	win = api_openwin(winbuf, w * 8 + 16, h * 16 + 37 + 15, -1, "GNXv[");
	api_boxfilwin(win, 8, 29 + 15, w * 8 + 7, h * 16 + 29 + 15, 7);

	/* t@Cǂݍ */
	*r = 0;
	i = api_fopen(q);
	if (i == 0) {
		api_putstr0("Corrupted system files.\n");
		api_end();
	}
	j = api_fsize(i, 0);
	if (j >= 240 * 1024 - 1) {
		j = 240 * 1024 - 2;
	}
	txtbuf[0] = 0x0a; /* ԕp̉sR[h */
	api_fread(txtbuf + 1, j, i);
	api_fclose(i);
	txtbuf[j + 1] = 0;
	q = txtbuf + 1;
	for (p = txtbuf + 1; *p != 0; p++) {	/* ȒPɂ邽߂0x0d̃R[h */
		if (*p != 0x0d) {
			*q = *p;
			q++;
		}
	}
	*q = 0;

	/* C */
	p = txtbuf + 1;
	while (1) {
		textview(win, w, h, xskip, p, t, lang);
		i = api_getkey(1);
		if (i == 'Q' || i == 'q') {
			api_end();
		}
		if ('A' <= i && i <= 'F') {
			spd_x = 1 << (i - 'A');	/* 1, 2, 4, 8, 16, 32 */
		}
		if ('a' <= i && i <= 'f') {
			spd_y = 1 << (i - 'a');	/* 1, 2, 4, 8, 16, 32 */
		}
		if (i == '<' && t > 1) {
			t /= 2;
		}
		if (i == '>' && t < 256) {
			t *= 2;
		}
		if (i == 0x9e8) {
			nowline--;
			for (j = 0; j < spd_y; j++) {
				if (p == txtbuf + 1) {
					continue;
				}
				for (p--; p[-1] != 0x0a; p--); /* ꕶO0x0ał܂ł̂ڂ */
			}
		}
		if (i == 0x9f0) {
			nowline++;
			for (j = 0; j < spd_y; j++) {
				for (q = p; *q != 0 && *q != 0x0a; q++);
				if (q[1] == 0) {
					continue;
				}
				p = q + 1;
			}
		}
	}
}

char *skipspace(char *p)
{
	while (*p == ' ') p++;		/* Xy[Xǂݔ΂ */
	return p;
}

void textview(int win, int w, int h, int xskip, char *p, int tab, int lang)
{
	int i;
	api_boxfilwin(win + 1, 8, 29+15, w * 8 + 7, h * 16 + 28 + 15, 7);
	api_boxfilwin(win + 1, 8, 29, w * 8 + 7, 28 + 15, 8);
	api_boxfilwin(win + 1, 9, 30+15, w * 8 + 6, 16 + 28 + 15, RGB(51/43,153/43,255/43));
	for (i = 0; i < h; i++) {
		p = lineview(win, w, i * 16 + 29, xskip, p, tab, lang);
	}
	api_refreshwin(win, 8, 29, w * 8 + 8, h * 16 + 29 + 15);
	return;
}

char *lineview(int win, int w, int y, int xskip, unsigned char *p, int tab, int lang)
{
	int x = -xskip;
	char s[130];
	while (1) {
		if (*p == 0)
			break;
		if (*p == 0x0a) {
			p++;
			break;
		}
		if (lang == 0) {	/* ASCII */
			if (*p == 0x09) {
				x = puttab(x, w, xskip, s, tab);
			} else {
				if (0 <= x && x < w) {
					s[x] = *p;
				}
				x++;
			}
			p++;
		}
		if (lang == 1) {	/* SJIS */
			if (*p == 0x09) {
				x = puttab(x, w, xskip, s, tab);
				p++;
			} else if ((0x81 <= *p && *p <= 0x9f) || (0xe0 <= *p && *p <= 0xfc)) {
				/* Sp */
				if (x == -1) {
					s[0] = ' ';
				}
				if (0 <= x && x < w - 1) {
					s[x]     = *p;
					s[x + 1] = p[1];
				}
				if (x == w - 1) {
					s[x] = ' ';
				} 
				x += 2;
				p += 2;
			} else {
				if (0 <= x && x < w) {
					s[x] = *p;
				}
				x++;
				p++;
			}
		}
		if (lang == 2) {	/* EUC */
			if (*p == 0x09) {
				x = puttab(x, w, xskip, s, tab);
				p++;
			} else if (0xa1 <= *p && *p <= 0xfe) {
				/* Sp */
				if (x == -1) {
					s[0] = ' ';
				}
				if (0 <= x && x < w - 1) {
					s[x]     = *p;
					s[x + 1] = p[1];
				}
				if (x == w - 1) {
					s[x] = ' ';
				} 
				x += 2;
				p += 2;
			} else {
				if (0 <= x && x < w) {
					s[x] = *p;
				}
				x++;
				p++;
			}
		}
	}
	if (x > w) {
		x = w;
	}
	if (x > 0) {
		s[x] = 0;
		api_putstrwin(win + 1, 30, y+15, 0, x, s);
	}
	return p;
}

int puttab(int x, int w, int xskip, char *s, int tab)
{
	while (1) {
		if (0 <= x && x < w) {
			s[x] = ' ';
		}
		x++;
		if ((x + xskip) % tab == 0) {
			break;
		}
	}
	return x;
}
