#include "../apilib.h"

#include <stdio.h>
#include <string.h>

//
//					z+edit
//									By moge32
//
//		MOGEXpeLXgGfB^łB
//		vOɂقƂǃRgȂ̂
//		ǂŉĂ̂͐ĂˁB
//
//

void textbox_enter(void);
void textbox_bksp(void);
void textbox_input(char key);
void insert(char input);
void deletes(void);
char *skipspace(char *p);
void textview(int win, int w, int h, int xskip, char *p, int tab, int lang);
char *lineview(int win, int w, int y, int xskip, unsigned char *p, int tab, int lang);
int puttab(int x, int w, int xskip, char *s, int tab);

char txtbuf[0x7ff];
int entermaxbuf[0x7ff];
int inputmax = 1;
char *cursor;
int curx = 0, cury = 0, curline = 0, line = 0;
int w = 30, h = 10, xskip = 0, scroll = 0;

int printf(const char *format, ...) {
	va_list ap;
	char s[1000];
	int i;

	va_start(ap, format);
	i = vsprintf(s, format, ap);
	api_putstr0(s);
	va_end(ap);
	return i;
}

void main(void)
{
	short winbuf[1024 * 757];
	int t = 4, tmp = 0;
	int win, i, lang = api_getlang();
	char *p, *q = 0;
	struct MOUSE_INFO minfo;

	/* EBhȄ */
	win = api_openwin(winbuf, w * 8 + 16 + 16, h * 16 + 37, -1, "z+edit");
	api_boxfilwin(win, 8, 28, w * 8 + 8, h * 16 + 28, 7);

	txtbuf[0] = 0x0a; // ԕp̉sR[h 
	q = txtbuf + 1;
	for (p = txtbuf + 1; *p != 0; p++) {	// ȒPɂ邽߂0x0d̃R[h
		if (*p != 0x0d) {
			*q = *p;
			q++;
		}
	}
	*q = 0;

	/* C */
	p = txtbuf + 1;
	cursor = p;
	while (1) {
		textview(win, w, h, xskip, p, t, lang);
		i = api_getkey(1);
		tomo_getmouse(win, &minfo);
		if (i == 0x0a) {		/* CR(s) */
			textbox_enter();
		} else if (i == 0x08) {	/* BackSpace */
			textbox_bksp();
		} else if (i == 0x9eb) {
			if (cursor != &txtbuf[1])
			{
				if (cursor[-1] == 0x0a)
				{
					curline--;
					curx = entermaxbuf[curline];
					cury--;
					line--;
					if (line < 0) {
						cury++;
						line++;
						scroll = -1;
					}
				} else {
					tmp--;
					curx--;
				}
				cursor--;
			}
		} else if (i == 0x9ed) {
			if (cursor != &txtbuf[inputmax])
			{
				if (*cursor == 0x0a)
				{
					curline++;
					curx = 0;
					cury++;
					line++;
					if (line >= h) {
						cury--;
						line--;
						scroll = 1;
					}
				} else {
					curx++;
				}
				cursor++;
			}
		} else if (i == 0x9e8 || i == 0x9f0) {
		} else {				/* ̑̃L[ */
			textbox_input(i);
		}

		if (scroll > 0) {
			for (q = p; *q != 0 && *q != 0x0a; q++);
			if (*q == 0) break;
			p = q + 1;
		} else if (scroll < 0) {
			if (p == txtbuf + 1) break;
			for (p--; p[-1] != 0x0a; p--); /* ꕶO0x0ał܂ł̂ڂ */
		}
		scroll = 0;
		tmp = 0;

		int fh;
		fh = (int)api_fopenEx("0.txt", 0);
		api_fwrite(&txtbuf[1], inputmax+1, fh);
		api_fcloseEx(fh);
	}
}

void textbox_enter(void)
{
	insert(0x0a);
	curx = 0;
	cury++;
	line++;
	curline++;
	cursor++;
	inputmax++;
	xskip = 0;
	if (line >= h) {
		scroll = 1;
		line--;
		cury = h-1;
	}
}

void textbox_bksp(void)
{
	if (cursor == &txtbuf[1]) {
		curx = cury = 0;
		return;
	}
	if (cursor[-1] == 0x0a)
	{
		//char *p = (char *)(entermaxbuf+1);
		//while (p != (char *)(entermaxbuf+0x7ff)) {
		//	p[0] = p[-1]+1;
		//	p++;
		//}
		curline--;
		//entermaxbuf[curline] += entermaxbuf[curline+1] + 1;
		curx = entermaxbuf[curline];
		cury--;
		if (line == 0) {
			cury++;
			line++;
			scroll = -1;
		}
		line--;
	} else {
		curx--;
		entermaxbuf[curline]--;
	}

	deletes();
	cursor--;
	inputmax--;
}

void textbox_input(char key)
{
	if (entermaxbuf[cury] >= w)
		return;
	insert(key);
	curx++;
	cursor++;
	inputmax++;
	entermaxbuf[curline]++;
}

// J[\ʒu1ǉ
void insert(char input)
{
	char *p = &txtbuf[inputmax];

	while (p != cursor)	// 납當ЂƂ炷B
	{
		p[0] = p[-1];
		p--;
	}
	*cursor = input;	// J[\ʒuɈꕶ
}

void deletes(void)
{
	char *p = &cursor[-1];
	while (p != &txtbuf[inputmax])
	{
		p[0] = p[1];
		p++;
	}
}

char *skipspace(char *p)
{
	while (*p == ' ') p++;		/* Xy[Xǂݔ΂ */
	return p;
}

void textview(int win, int w, int h, int xskip, char *p, int tab, int lang)
{
	int i;
	int cx, cy;

	api_boxfilwin(win, 8, 28, w * 8 + 10, h * 16 + 28, 7);
	for (i = 0; i < h; i++) {
		p = lineview(win, w, i * 16 + 28, xskip, p, tab, lang);
	}
	cx = 8 + curx * 8;
	cy = 28 + cury * 16;
	if (cx >= 0 || cx <= w || cy >= 0 || cy <= h) {
		api_boxfilwin(win, cx, cy, cx + 1, cy + 16, 0);
	}
	api_boxfilwin(win, w * 8 + 10, cy, w * 8 + 10 + 15, h * 16 + 28, 15);
	api_refreshwin(win, 8, 28, w * 8 + 10, h * 16 + 28);
	return;
}

char *lineview(int win, int w, int y, int xskip, unsigned char *p, int tab, int lang)
{
	int x = - xskip;
	int count = 0;
	char s[130];

	for (;;) {
		if (*p == 0) {
			break;
		}
		if (*p == 0x0a) {
			p++;
			break;
		}
		if (count > w) {
			break;
		}
		if (lang == 0) {	/* ASCII */
			if (*p == 0x09) {
				x = puttab(x, w, xskip, s, tab);
			} else {
				if (0 <= x && x < w) {
					s[x] = *p;
				}
				x++;
			}
			p++;
		}
		if (lang == 1) {	/* SJIS */
			if (*p == 0x09) {
				x = puttab(x, w, xskip, s, tab);
				p++;
			} else if ((0x81 <= *p && *p <= 0x9f) || (0xe0 <= *p && *p <= 0xfc)) {
				/* Sp */
				if (x == -1) {
					s[0] = ' ';
				}
				if (0 <= x && x < w - 1) {
					s[x]     = *p;
					s[x + 1] = p[1];
				}
				if (x == w - 1) {
					s[x] = ' ';
				} 
				x += 2;
				p += 2;
			} else {
				if (0 <= x && x < w) {
					s[x] = *p;
				}
				x++;
				p++;
			}
		}
		if (lang == 2) {	/* EUC */
			if (*p == 0x09) {
				x = puttab(x, w, xskip, s, tab);
				p++;
			} else if (0xa1 <= *p && *p <= 0xfe) {
				/* Sp */
				if (x == -1) {
					s[0] = ' ';
				}
				if (0 <= x && x < w - 1) {
					s[x]     = *p;
					s[x + 1] = p[1];
				}
				if (x == w - 1) {
					s[x] = ' ';
				} 
				x += 2;
				p += 2;
			} else {
				if (0 <= x && x < w) {
					s[x] = *p;
				}
				x++;
				p++;
			}
		}
		count++;
	}
	if (x > w) {
		x = w;
	}
	if (x > 0) {
		s[x] = 0;
		api_putstrwin(win + 1, 8, y, 0, x, s);
	}
	return p;
}

int puttab(int x, int w, int xskip, char *s, int tab)
{
	for (;;) {
		if (0 <= x && x < w) {
			s[x] = ' ';
		}
		x++;
		if ((x + xskip) % tab == 0) {
			break;
		}
	}
	return x;
}

/* end of tedit.c */
